/*
* prefdlg.h -- Declaration of class KViewPrefDlg.
* Generated by newclass on Fri Jan  1 16:15:08 EST 1999.
*/
#ifndef SSK_PREFDLG_H
#define SSK_PREFDLG_H

#include<qtabdialog.h>
#include<kkeydialog.h>

class QCheckBox;
class KConfig;
class QRadioButton;
class QLineEdit;
class KAccel;

/**
* TabDialog for kView preferences.
* @author Sirtaj Singh Kang (taj@kde.org)
* @version $Id: prefdlg.h,v 1.1 1999/01/10 18:16:51 ssk Exp $
*/
class KViewPrefDlg : public QTabDialog
{

	Q_OBJECT

public:
	/**
	* KViewPrefDlg Constructor
	*/
	KViewPrefDlg( KConfig *cfg, KAccel *accel, QWidget *parent = 0 );

	/**
	* KViewPrefDlg Destructor
	*/
	virtual ~KViewPrefDlg() {}
	
	bool keysDirty() const;
private:
	QCheckBox	*_aMax;
	QCheckBox	*_loop;
	QLineEdit	*_interval;

	QRadioButton	*_rw;
	QRadioButton	*_ri;
	QRadioButton	*_rn;
	
	KConfig		*_cfg;

	KAccel		*_accel;
	bool		_keysDirty;
	QDict<KKeyEntry> _dict;		

private slots:
	void applySettings();
	void setKeysDirty() { _keysDirty = true; }

private:
	KViewPrefDlg& operator=( const KViewPrefDlg& );
	KViewPrefDlg( const KViewPrefDlg& );
};

inline bool KViewPrefDlg::keysDirty() const
{
	return _keysDirty;
}

#endif // SSK_PREFDLG_H
